QSSPN Software
=============

This is the Quasi-Stable State Petri Network simulation software.
Developed by Andrzej Kierzek ([A.Kierzek@surrey.ac.uk](A.Kierzek@surrey.ac.uk))
and Wojciech Ptak ([wojtek.ptak@gmail.com](mailto:wojtek.ptak@gmail.com)).

Please note that the software is highly experimental.
You will probably have to solve a few unexpected problems during installation or running yourself.


Building
-----------
The software requires GNU Linear Programming Kit.
On Debian-based systems, it is available via `libglpk-dev` package:

```
sudo apt-get install libglpk-dev
```

Please refer to [GLPK homepage](http://www.gnu.org/software/glpk/)
for details and information on how to install on different operating
systems.

The QSSPN software uses Apache Thrift to communicate with external
programs. You need a decent version installed - refer to
[Apache Thrift tutorial](https://thrift.apache.org/tutorial/).

After having installed Thrift, issue the following to bootstrap the build of the QSSPN:

```
cd PROJECT_DIR/v3.3
mkdir build
cd build
cmake ..
```

It is enough to do this once; the generated build description can
be reused for subsequent builds. You should rerun `cmake` only if
you make substantial changes to the code (rename/create/delete
source files, change thrift interface definitions).

Now you can build the project using GNU Make by issuing

```
cd PROJECT_DIR/v3.3/build
make
```

Running
------
The compiled binaries (`qsspn_server`, `qsspn_proxy`, `qsspn_standalone` and `qsspn_example_thrift_client`) will
be placed in `v3.3/build/src/bin` directory. Running them by hand isn't very convenient,
so there us a wrapper script in `scripts/qsspn_runner.py` to make it easier.
Run `scripts/qsspn_runner.py -h` for more information.

After a successful build, the binary will be placed in `v3.3/bin/qsspn`.
To make using it easier, there is a shortcut script in `scripts/qsspn_runner`. To run it on bile acid model, run

```
./scripts/qsspn_runner.sh
```
The simulation results and logs will be available in `workspace_standalone_{current_time}` directory.

To verify the thrift integration, start the three flavors of QSSPN by specifying
the `--mode` parameter: `server`, `proxy` and `thrift_client` (in this order).
The server should perform the calculations, the proxy will expose a thrift
server, and thrift_client will use it to request calculations. The
thrift_client should exit after the simulation is complete and log the results,
similar to the standalone mode.
