/*
 * File:   Cache.h
 * Author: Jacek Sroka
 */
#ifndef _CACHE_H
#define	_CACHE_H

#include <map>
#include <iostream>

class Cache {
private:
    std::size_t max_size;
    std::size_t current_size;
    std::map<std::string, double> map;
    std::string saveTo;

    int last_save_size = 0;

    void clearIfTooBig();
public:
    Cache(unsigned long int);
    Cache(unsigned long int max_size, std::istream& input, std::string& outfilename);
    virtual ~Cache();

    bool isPresent(const std::string& key);
    double getValue(const std::string& key);
    void setValue(const std::string& key, double val);

    void serialize(std::ostream& out);

};

#endif	/* _CACHE_H */
