#include "PlaceTracker.h"

#include <iostream>
using namespace std;


void SinglePlaceTracker::reset() {
  _produced = 0;
  _consumed = 0;
}

void SinglePlaceTracker::updateCalled(double from, double by) {
  if (by == 0) return;

  if (by == 1) {
    _produced++;
    return;
  }

  if (by == -1) {
    _consumed++;
    return;
  }
  cerr << "Suspicious update called: " << by << endl;
}

int SinglePlaceTracker::produced() {
  return _produced;
}

int SinglePlaceTracker::consumed() {
  return _consumed;
}

void PlaceTracker::reset() {
  for (int i = 0; i < trackers.size(); i++) {
    trackers[i].reset();
  }
}

int PlaceTracker::registerPlace() {
  trackers.push_back(SinglePlaceTracker());
  return trackers.size() - 1;
}

vector<bool> PlaceTracker::getProductionSummary() {
  vector<bool> result(trackers.size());
  for (int i=0; i<trackers.size(); i++) {
    result[i] = (produced(i) > 0);
    if (produced(i)> 0 && consumed(i) > 0) {
      cout << "Warning: substance tracked with idx " << i << " is both produced and consumed ";
      cout << "(+" << produced(i) << ", -" << consumed(i) << ")" << endl;
    }
  }
  return result;
}

int PlaceTracker::produced(int uid) {
  return trackers[uid].produced();
}

int PlaceTracker::consumed(int uid) {
  return trackers[uid].consumed();
}

void PlaceTracker::updateCalled(int uid, double from, double by) {
  trackers[uid].updateCalled(from, by);
}
