#ifndef __PLACE_TRACKER_H__
#define __PLACE_TRACKER_H__

#include <vector>
using std::vector;


class SinglePlaceTracker;


/* Tracks a selection of Petri net nodes for changes */
class PlaceTracker {
public:

  void reset();
  int  registerPlace(); /* returns a unique ID of the place */
  void updateCalled(int    uid,
                    double oldstate,
                    double by);
  int  produced(int uid);
  int  consumed(int uid);
  vector<bool> getProductionSummary();

private:

  vector<SinglePlaceTracker> trackers;
};


/* Tracks a single place in Petri node for changes */
class SinglePlaceTracker {
public:

  void reset();
  void updateCalled(double oldstate,
                    double by);

  /* Return count of how many times given place was marked/unmarked since reset
   */
  int produced();
  int consumed();

private:

  int _produced = 0;
  int _consumed = 0;
};

#endif // ifndef __PLACE_TRACKER_H__
