#ifndef __SINGLE_STEP_SERVICE_H__
#define __SINGLE_STEP_SERVICE_H__

#include "PetriNet.h"
#include "SingleStepProxy.h" // thrift generated
#include <vector>

class SingleStepHandler : public SingleStepProxyIf {
public:

  SingleStepHandler(const string& qsspn_file,
                    const string& ctrl_file,
                    const string& srv_addr,
                    const string& srv_port);

  void calculateStep(StepResult   & result,
                     const Marking& input);
  void describeModel(ModelDescription& result);

private:

  PetriNet pn;
  ModeConfiguration::Config config;
  vector<bool> defaultMarking;

  void setMarking(const Marking& input);
  void runStep();
  void extractMarking(StepResult& to);
  void extractResult(StepResult& to);
};
#endif // ifndef __SINGLE_STEP_SERVICE_H__
