#include "../MetabolismServer.h"
#include "../ModeConfiguration.h"
#include "../PetriNet.h"

#include <asio.hpp>
#include <iostream>
using namespace std;

void print_usage(const string& self) {
    cout << "Usage: " << self << " QSSPN_FILE CTRL_FILE\n"
         << "Generates metabolism for encodings for PARTITION_ID assuming there are PARTITIONS_COUNT partitions.\n"
         << "Where PARTITION_ID and PARTITIONS_COUNT are two first lines of input.\n";
}

int main(int argc, char **argv) {
    if (argc < 2) {
        print_usage(argv[0]);
        return 1;
    }
    string qsspn_file(argv[1]);
    string ctrl_file(argv[2]);
    int partition_id;
    int partitions_count;

    cin >> partition_id >> partitions_count;

    ModeConfiguration::Config config;

    PetriNet pn = new PetriNet(false);

    pn.readPetriNet(qsspn_file);
    pn.oneTimeSetup(ctrl_file, config);

    pn.preTrajectorySetup(); // This allocates a Trajectory object...
    pn.generateCachePartition(config, partition_id, partitions_count, true);
}

