#include "../MetabolismServer.h"

#include <iostream>
using namespace std;

void print_usage(const string& self) {
  cout << "Usage: " << self << " QSSPN_FILE CTRL_FILE ADDRESS PORT CACHE_SIZE [LOAD_CACHE_FROM [SAVE_CACHE_TO]]\n"
       << "Runs QSSPN server.\n\n"
       << "CACHE_SIZE is rouchly the maximum number of allocated chars.\n";
}

int main(int argc, char **argv) {
  if (argc < 6 || argc > 8) {
    print_usage(argv[0]);
    return 1;
  }
  string qsspn_file(argv[1]);
  string ctrl_file(argv[2]);
  string addr(argv[3]);
  string port(argv[4]);
  int    cache_size = atoi(argv[5]);

  Cache* cache;
  if (argc > 6) {
    ifstream input(argv[6]);
    string saveTo = "";
    if (argc == 8) {
      saveTo = string(argv[7]);
    }
    cache = new Cache(cache_size, input, saveTo);
  } else {
    cache = new Cache(cache_size);
  }
  PetriNet pn;

  pn.readPetriNet(qsspn_file);
  ModeConfiguration::Config config;
  config.mode = ModeConfiguration::SERVER;

  pn.oneTimeSetup(ctrl_file, config);

  asio::io_service io_service;

  MetabolismServer server(addr, port, io_service, 1, &pn, cache);

  server.run();
}
