#include "EnzymesTokensEncoder.h"
#include "BinaryEnzymesTokensEncoder.h"

#include <iostream>

using namespace std;

BinaryEnzymesTokensEncoder::BinaryEnzymesTokensEncoder() : EnzymesTokensEncoder() {
}

BinaryEnzymesTokensEncoder::BinaryEnzymesTokensEncoder(vector<SubstanceInterface*> enzymes) : EnzymesTokensEncoder(enzymes) {
}

int BinaryEnzymesTokensEncoder::getMaximalEncoding() {
	int s = enzymes.size();
	if (s == 0) return 0;
	return 1 << enzymes.size();
}

int BinaryEnzymesTokensEncoder::encode() {
	int encoding = 0;
	int component = 0;
	for (int i = 0; i < enzymes.size(); ++i) {
		if (component == 0) {
			component = 1;
		} else {
			component = component * 2;
		}
		encoding += component*enzymes[i]->getTokens();
	}
	return encoding;
}


void BinaryEnzymesTokensEncoder::decodeAndSetSubstancesStates(int encoding){
	int i = 0;
	int left = encoding;
	while (left > 0) {
		if (left % 2 == 1) {
			enzymes[i]->setTokens(1);
		} else {
			enzymes[i]->setTokens(0);
		}
		left = left / 2;
		++i;
	}
}


BinaryEnzymesTokensEncoder::~BinaryEnzymesTokensEncoder() {
}
