#include "BinaryMetabolismCache.h"
#include "MetabolismCache.h"

#include <istream>
#include <string>
#include <vector>

#include "log.h"

using namespace std;

BinaryMetabolismCache::BinaryMetabolismCache() {}

BinaryMetabolismCache::BinaryMetabolismCache(istream* argDataStream) : MetabolismCache(argDataStream) {
	FILELog::ReportingLevel() = logINFO;
	string line;
	while (!dataStream->eof()) {
	    getline(*dataStream, line);
	    FILE_LOG(logDEBUG) << "Loading line: " << line;
		loadLine(line);
	}
}

vector<double>* BinaryMetabolismCache::get(int key) {
	return data[key];
}

BinaryMetabolismCache::~BinaryMetabolismCache() {}

void BinaryMetabolismCache::loadLine(string line) {
	istringstream* lineStream = new istringstream(line);
	int row;
	*lineStream >> row;
    FILE_LOG(logDEBUG) << "Processing row for key " << row;
	string substance;
	vector<double>* states = new vector<double>;
    double state;
    while (lineStream->good()) {
    	*lineStream >> substance >> state;
	    FILE_LOG(logDEBUG) << "Loaded substance " << substance << " in state " << state;
    	states->push_back(state);
    }
    data.push_back(states);
}
