#ifndef SRC_METABOLISM_SUBSTANCEINTERFACE_H_
#define SRC_METABOLISM_SUBSTANCEINTERFACE_H_

#include <string>
#include "../EnzymeActivity.h"
#include "DriverInterface.h"

using namespace std;

class SubstanceInterface {
public:
	SubstanceInterface();
	virtual ~SubstanceInterface();
	virtual string getName()=0;
	virtual int getTokens()=0;
	virtual void setTokens(int count)=0;
    virtual bool enzymeAction(DriverInterface *gsmn)=0;
    virtual void setEnzymeBounds(DriverInterface *gsmn)=0;
    virtual void setEnzymeActivity(EnzymeActivity enz)=0;
    virtual void allocateRWeights(int n)=0;
    virtual double getRWeight(int n)=0;
    virtual void setRWeight(int n, double w)=0;
    virtual string getGsmnReaction()=0;
    virtual string getGsmnReaction(int n)=0;
    virtual void setGsmnReaction(string rn)=0;
    virtual EnzymeActivity getEnzymeActivity()=0;
    virtual int numberOfGsmnReactions()=0;
};

#endif
