#include "MetabolismCache.h"
#include "BinaryMetabolismCache.h"
#include "gtest/gtest.h"
#include "gmock/gmock.h"

#include <iostream>
#include <vector>

using namespace std;

using ::testing::Return;
using ::testing::_;

TEST(MetabolismCache, SingleRowSingleValue) {
	istream* data = new stringstream("0 EnzymeWithToken 1");
	MetabolismCache *cache = new BinaryMetabolismCache(data);
	vector<double>* states = cache->get(0);
    ASSERT_EQ(1, states->at(0));
}

TEST(MetabolismCache, ManyValues) {
	istream* data = new stringstream("0 EnzymeWithToken 1 EnzymeWithoutToken 0");
	MetabolismCache *cache = new BinaryMetabolismCache(data);
	vector<double>* states = cache->get(0);
    ASSERT_EQ(1, states->at(0));
    ASSERT_EQ(0, states->at(1));
}

TEST(MetabolismCache, ManyRows) {
	istream* data = new stringstream("0 EnzymeWithToken 1\n1 EnzymeWithoutToken 0");
	MetabolismCache *cache = new BinaryMetabolismCache(data);
    ASSERT_EQ(1, cache->get(0)->at(0));
    ASSERT_EQ(0, cache->get(1)->at(0));
}
