Distributed Simulations
=======================


Running
-------

1. First you need a working version of QSSPN module.
See `QSSPN/QSSPNClientBuf2/README.md` for details.

2. Spark installation (preferably a cluster).
I ran this application on Spark standalone and local;
it should work on YARN/mesos as well.

3. Tricky part: every worker node in the cluster needs to have QSSPN proxy
    running. The worker nodes will try to connect to localhost via trhift
    and the job will fail if QSSPN proxy or server does not respond.

4. Submit the job to the cluster:

        spark-submit \
          --master=spark://$SPARK_MASTER \
          --class biosim.Main \
          --workers $WORKERS \
          $JAR $SIZE $STEPS

  The parameters are:
  * SPARK_MASTER - URL to your spark cluster master
  * WORKERS - the nubmer of worker nodes to use (if less than the cluster size, spark will choose a subset of workers)
  * JAR - path to the assembled jar file
  * SIZE - cell system size. The system itself is a cube, it will have SIZE * SIZE * SIZE cells.
  * STEPS - number of steps to run. Homeostasis usually occurs somewhere between steps 50 and 150.
