val qsspnPath = "~/SparkLP/QSSPN/QSSPNclientBuff2"
val precomputerPath = qsspnPath + "/v3.3/src/bin/qsspn_metabolism-precomputer"
val modelPath = qsspnPath + "/models/BileAcidHomeostasis1.0.qsspn"
val controlFilePath = qsspnPath + "/models/BileAcidHomeostasis1.0.ctrl.txt"
val call = precomputerPath + " " + modelPath + " " + controlFilePath + " 127.0.0.1 30130"

val parts = sc.defaultParallelism * 10

val precomputedMetabolismRdd = sc.parallelize(1 to parts, parts).
                                 mapPartitionsWithIndex( (i, it) => it.map(x => i.toString + "\n" + parts.toString), true ).
                                 pipe(call).filter( x => !x.startsWith("Tracking") ).
                                 sortBy( x => x.split(" ")(0).toInt )
val precomputedMetabolismCases = precomputedMetabolismRdd.collect
val precomputedCases = precomputedMetabolismCases.size
val precomputedMetabolism = precomputedMetabolismCases.mkString("\n")
scala.tools.nsc.io.File("/tmp/cache.txt").writeAll(precomputedMetabolism)

System.exit()
