#!/bin/bash

if [ "$#" -ne 3 ]; then
  echo "Usage: metabolism-precomputer.sh SPARK_MASTER SPARK_SLAVES_FILE MEMORY_LIMIT"
  echo "SPARK_MASTER - hostname of spark master"  
  echo "SPARK_SLAVES_FILE - path to file containing slaves' hostnames"  
  echo "MEMORY_LIMIT - floor( slave_memory / 2 )"
fi

unbuffer spark-shell --executor-memory ${3}g --executor-cores 1 --master spark://${1}:7077 -i metabolism-precomputer.sc 2>&1 >mp.log

while read slave_hostname; do
  scp /tmp/cache.txt ${slave_hostname}:/tmp
done <${2}
