Multi-cell QSSPN simulations on Spark
=====================================


This is a library designed for running distributed multi-cellular
simulations on Apache Spark clusters. It currently depends
on QSSPNClientBuff2 software to perform local QSSPN computations.

Prequesites
-----------

  * Decent JDK
  * QSSPNClientBuff2 v3.3, see QSSPN/QSSPNClientBuff2/README.md for details

Usage
-----

Build the jar via sbt: `sbt assembly`.
The result is a jar in `target/scala-2.10` with entrypoint
in the class `biosim.Main`. Usage is
`biosimMain <size> <steps>` where `size` is the number of cells along
one edge of the cube and `steps` is the number of simulation steps.
The simulation will cover total of `size * size * size` cells.
The workers will connect to qsspn thrift proxies on their localhosts,
so make sure the QSSPN servers and proxies are running on all the
worker nodes before launching the spark job.


For convenient sanity-check use `sbt runSpark` - it builds the jar
and runs a very small system on your local spark in local mode
(you just need to have `SPARK_HOME` set).
