/**
 * Generated by Scrooge
 *   version: 3.20.0
 *   rev: 0805321d69745466806017e1167a5027cd298d66
 *   built at: 20150808-111207
 */
package thrift

import com.twitter.finagle.{SourcedException, Service}
import com.twitter.finagle.stats.{NullStatsReceiver, StatsReceiver}
import com.twitter.finagle.thrift.{Protocols, ThriftClientRequest}
import com.twitter.scrooge.{ThriftStruct, ThriftStructCodec}
import com.twitter.util.{Future, Return, Throw, Throwables}
import java.nio.ByteBuffer
import java.util.Arrays
import org.apache.thrift.protocol._
import org.apache.thrift.TApplicationException
import org.apache.thrift.transport.{TMemoryBuffer, TMemoryInputTransport}
import scala.collection.{Map, Set}

import scala.language.higherKinds


@javax.annotation.Generated(value = Array("com.twitter.scrooge.Compiler"))
class SingleStepProxy$FinagleClient(
    val service: Service[ThriftClientRequest, Array[Byte]],
    val protocolFactory: TProtocolFactory = Protocols.binaryFactory(),
    val serviceName: String = "SingleStepProxy",
    stats: StatsReceiver = NullStatsReceiver
) extends SingleStepProxy[Future] {
  import SingleStepProxy._

  protected def encodeRequest(name: String, args: ThriftStruct) = {
    val buf = new TMemoryBuffer(512)
    val oprot = protocolFactory.getProtocol(buf)

    oprot.writeMessageBegin(new TMessage(name, TMessageType.CALL, 0))
    args.write(oprot)
    oprot.writeMessageEnd()

    val bytes = Arrays.copyOfRange(buf.getArray, 0, buf.length)
    new ThriftClientRequest(bytes, false)
  }

  protected def decodeResponse[T <: ThriftStruct](resBytes: Array[Byte], codec: ThriftStructCodec[T]) = {
    val iprot = protocolFactory.getProtocol(new TMemoryInputTransport(resBytes))
    val msg = iprot.readMessageBegin()
    try {
      if (msg.`type` == TMessageType.EXCEPTION) {
        val exception = TApplicationException.read(iprot) match {
          case sourced: SourcedException =>
            if (serviceName != "") sourced.serviceName = serviceName
            sourced
          case e => e
        }
        throw exception
      } else {
        codec.decode(iprot)
      }
    } finally {
      iprot.readMessageEnd()
    }
  }

  protected def missingResult(name: String) = {
    new TApplicationException(
      TApplicationException.MISSING_RESULT,
      name + " failed: unknown result"
    )
  }

  protected def setServiceName(ex: Throwable): Throwable =
    if (this.serviceName == "") ex
    else {
      ex match {
        case se: SourcedException =>
          se.serviceName = this.serviceName
          se
        case _ => ex
      }
    }

  // ----- end boilerplate.

  private[this] val scopedStats = if (serviceName != "") stats.scope(serviceName) else stats
  private[this] object __stats_describeModel {
    val RequestsCounter = scopedStats.scope("describeModel").counter("requests")
    val SuccessCounter = scopedStats.scope("describeModel").counter("success")
    val FailuresCounter = scopedStats.scope("describeModel").counter("failures")
    val FailuresScope = scopedStats.scope("describeModel").scope("failures")
  }
  
  def describeModel(): Future[ModelDescription] = {
    __stats_describeModel.RequestsCounter.incr()
    this.service(encodeRequest("describeModel", DescribeModel.Args())) flatMap { response =>
      val result = decodeResponse(response, DescribeModel.Result)
      val exception: Future[Nothing] =
        null
  
      if (result.success.isDefined)
        Future.value(result.success.get)
      else if (exception != null)
        exception
      else
        Future.exception(missingResult("describeModel"))
    } respond {
      case Return(_) =>
        __stats_describeModel.SuccessCounter.incr()
      case Throw(ex) =>
        setServiceName(ex)
        __stats_describeModel.FailuresCounter.incr()
        __stats_describeModel.FailuresScope.counter(Throwables.mkString(ex): _*).incr()
    }
  }
  private[this] object __stats_calculateStep {
    val RequestsCounter = scopedStats.scope("calculateStep").counter("requests")
    val SuccessCounter = scopedStats.scope("calculateStep").counter("success")
    val FailuresCounter = scopedStats.scope("calculateStep").counter("failures")
    val FailuresScope = scopedStats.scope("calculateStep").scope("failures")
  }
  
  def calculateStep(marking: Marking): Future[StepResult] = {
    __stats_calculateStep.RequestsCounter.incr()
    this.service(encodeRequest("calculateStep", CalculateStep.Args(marking))) flatMap { response =>
      val result = decodeResponse(response, CalculateStep.Result)
      val exception: Future[Nothing] =
        null
  
      if (result.success.isDefined)
        Future.value(result.success.get)
      else if (exception != null)
        exception
      else
        Future.exception(missingResult("calculateStep"))
    } respond {
      case Return(_) =>
        __stats_calculateStep.SuccessCounter.incr()
      case Throw(ex) =>
        setServiceName(ex)
        __stats_calculateStep.FailuresCounter.incr()
        __stats_calculateStep.FailuresScope.counter(Throwables.mkString(ex): _*).incr()
    }
  }
}
