
val VERSION = "0.2.1"
scalaVersion := "2.11.6"

lazy val globalSettings = Seq(
        name := """spark-multi-cell-simulation""",
        version := VERSION,
        scalaVersion := "2.11.6",
        scalacOptions ++= Seq("-feature", "-deprecation")
)

resolvers += "Twitter" at "https://maven.twttr.com"


lazy val spark_home = sys.env.get("SPARK_HOME")

libraryDependencies ++= Seq(
  "org.apache.spark" % "spark-core_2.11" % "2.0.1",
  "org.apache.spark" % "spark-graphx_2.11" % "2.0.1",
  "org.scalatest" % "scalatest_2.11" % "2.2.4" % "test",
  "org.apache.thrift" % "libthrift" % "0.5.0",
  "com.twitter" %% "finagle-thrift" % "6.27.0",
  "org.log4s" %% "log4s" % "1.1.5"
)


val runSpark = TaskKey[Unit]("runSpark")


runSpark <<= assembly map { file =>
  import scala.sys.process._
  val cmd = spark_home.map(_ + "/bin/spark-submit")
  cmd.map(sparkSubmit =>
    Seq(sparkSubmit,
      "--class", "biosim.Main",
      "--master", "local[4]",
      file.getAbsolutePath, "5", "23", "checkpoints").!
  ).getOrElse(sys.error("SPARK_HOME not set"))
}


mergeStrategy in assembly <<= (mergeStrategy in assembly) { (old) =>
{
	case PathList("META-INF", xs @ _*) => MergeStrategy.discard
	case x => MergeStrategy.first
}
}
